//==============================================================================================================================================
// ПЕРЕМЕННЫЕ МОДУЛЯ
//==============================================================================================================================================

//==============================================================================================================================================
// ОБРАБОТЧИКИ СОБЫТИЙ ФОРМЫ
//==============================================================================================================================================

&НаСервере
Процедура ПриСозданииНаСервере(Отказ, СтандартнаяОбработка)
	
	Запрос = Новый Запрос();
	
	Запрос.Текст = "
		|ВЫБРАТЬ
		|	ДенежныеХранилища.Ссылка КАК ДенежноеХранилище,
		|	ДенежныеСредства.СуммаОстаток КАК ТекущаяСумма
		|ИЗ
		|	Справочник.ДенежныеХранилища КАК ДенежныеХранилища
		|	ЛЕВОЕ СОЕДИНЕНИЕ
		|		РегистрНакопления.ДенежныеСредства.Остатки(, Сценарий = ЗНАЧЕНИЕ(Справочник.Сценарии.Факт)) КАК ДенежныеСредства
		|	ПО
		|		ДенежныеСредства.ДенежноеХранилище = ДенежныеХранилища.Ссылка
		|ГДЕ
		|	ДенежныеХранилища.ПометкаУдаления = ЛОЖЬ
		|УПОРЯДОЧИТЬ ПО
		|	ДенежныеХранилища.ПорядокОтображения
		|";
	
	Выборка = Запрос.Выполнить().Выбрать();
	Пока Выборка.Следующий() Цикл
		
		СтрокаТЗ = ТаблицаДенежныхХранилищ.Добавить();
		ЗаполнитьЗначенияСвойств(СтрокаТЗ, Выборка);
		
	КонецЦикла;
	
	ДатаКорректировки = ТекущаяДата();
	
	СуммаИтого = ТаблицаДенежныхХранилищ.Итог("ТекущаяСумма");
	
КонецПроцедуры // ПриСозданииНаСервере()

//==============================================================================================================================================
// ОБРАБОТЧИКИ КОМАНД ФОРМЫ
//==============================================================================================================================================

&НаКлиенте
Процедура СоздатьКорректировку(Команда)
	
	Если Не ЗначениеЗаполнено(ДатаКорректировки) Тогда
		Возврат;
	КонецЕсли;
	
	СоздатьКорректировкуСервер();
	
КонецПроцедуры // СоздатьКорректировку()

//==============================================================================================================================================
// ОБРАБОТЧИКИ СОБЫТИЙ ЭЛЕМЕНТОВ ФОРМЫ
//==============================================================================================================================================

&НаКлиенте
Процедура ТаблицаДенежныхХранилищТекущаяСуммаПриИзменении(Элемент)
	
	СуммаИтого = ТаблицаДенежныхХранилищ.Итог("ТекущаяСумма");
	
КонецПроцедуры // ТаблицаДенежныхХранилищТекущаяСуммаПриИзменении()

//==============================================================================================================================================
// КЛИЕНТСКИЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

//==============================================================================================================================================
// КЛИЕНТ-СЕРВЕРНЫЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

//==============================================================================================================================================
// СЕРВЕРНЫЕ ПРОЦЕДУРЫ И ФУНКЦИИ ОБЩЕГО НАЗНАЧЕНИЯ
//==============================================================================================================================================

&НаСервере
Процедура СоздатьКорректировкуСервер()
	
	Запрос = Новый Запрос();
	
	Запрос.УстановитьПараметр("ДатаКорректировки", КонецДня(ДатаКорректировки));
	
	Запрос.Текст = "
		|ВЫБРАТЬ
		|	ДенежныеСредства.ДенежноеХранилище 			КАК ДенежноеХранилище,
		|	ДенежныеСредства.СуммаОстаток				КАК СуммаОстаток
		|ИЗ
		|	РегистрНакопления.ДенежныеСредства.Остатки(&ДатаКорректировки, Сценарий = ЗНАЧЕНИЕ(Справочник.Сценарии.Факт)) КАК ДенежныеСредства
		|
		|;
		|
		|ВЫБРАТЬ
		|	Ссылка
		|ИЗ
		|	Документ.ВводДвижений
		|ГДЕ
		|	КОНЕЦПЕРИОДА(Дата, ДЕНЬ) = &ДатаКорректировки
		|	И Проведен = ИСТИНА
		|	И Комментарий = ""Корректировка""
		|";
	
	ПакетыЗапросов = Запрос.ВыполнитьПакет();
	
	ЭтоНовый = Ложь;
	Если ПакетыЗапросов[1].Пустой() Тогда
		
		ДокументКорректировки = Документы.ВводДвижений.СоздатьДокумент();
		ДокументКорректировки.Дата 			= КонецДня(ДатаКорректировки);
		ДокументКорректировки.Комментарий 	= "Корректировка";
		ДокументКорректировки.Сценарий 		= Справочники.Сценарии.Факт;
		ДокументКорректировки.УстановитьНовыйНомер();
		
		ЭтоНовый = Истина;
		
	Иначе
		
		Выборка = ПакетыЗапросов[1].Выбрать();
		Выборка.Следующий();
		
		ДокументКорректировки = Выборка.Ссылка.ПолучитьОбъект();
		ДокументКорректировки.Подробности.Очистить();
		
	КонецЕсли;
	
	ТаблицаОстатков = ПакетыЗапросов[0].Выгрузить();
	Для Каждого СтрокаТЗ Из ТаблицаДенежныхХранилищ Цикл
		
		СтруктураОтбора = Новый Структура("ДенежноеХранилище", СтрокаТЗ.ДенежноеХранилище);
		МассивСтрок = ТаблицаОстатков.НайтиСтроки(СтруктураОтбора);
		Сумма = СтрокаТЗ.ТекущаяСумма - ?(МассивСтрок.Количество() > 0, МассивСтрок[0].СуммаОстаток, 0);
		
		СтрокаТЧ = ДокументКорректировки.Подробности.Добавить();
		СтрокаТЧ.Вид 				= Справочники.ВидыДоходовРасходов.Корректировка;
		СтрокаТЧ.ДенежноеХранилище 	= СтрокаТЗ.ДенежноеХранилище;
		СтрокаТЧ.Сумма 				= Сумма;
		
	КонецЦикла;
	
	ДокументКорректировки.Записать(РежимЗаписиДокумента.Проведение);
	Сообщить(?(ЭтоНовый, "Создан", "Изменен") + " документ " + ДокументКорректировки.Номер + " от " + ДокументКорректировки.Дата);
	
КонецПроцедуры // СоздатьКорректировкуСервер()

//==============================================================================================================================================
// ОПЕРАТОРЫ ОСНОВНОЙ ПРОГРАММЫ
//==============================================================================================================================================

